// DllSubDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "crystalmark.h"
#include "DllDlg.h"
#include "DllSubDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CDllDlg* P;

/////////////////////////////////////////////////////////////////////////////
// CDllSubDlg _CAO


CDllSubDlg::CDllSubDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDllSubDlg::IDD, pParent)
{
	P = (CDllDlg*)pParent;

	//{{AFX_DATA_INIT(CDllSubDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}


void CDllSubDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDllSubDlg)
	DDX_Control(pDX, IDC_DLL_SUB_LIST, m_DllSubList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDllSubDlg, CDialog)
	//{{AFX_MSG_MAP(CDllSubDlg)
//	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDllSubDlg bZ[W nh

void CDllSubDlg::OnOK() 
{
//	CDialog::OnOK();
}

void CDllSubDlg::OnCancel() 
{
//	CDialog::OnCancel();
}

BOOL CDllSubDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
/*	tHg̐ݒ
	CFont *pFont = new CFont;
	pFont->CreatePointFont(110,"lr oSVbN",NULL);
	m_DllSubList.SetFont(pFont,TRUE);
*/
// Xgr[̍\z
	LVCOLUMN myColumn;
	myColumn.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_ORDER ;

	// Rg[̕擾
	CRect cr;m_DllSubList.GetClientRect(cr);
	DWORD width = cr.Width();// - GetSystemMetrics(SM_CXVSCROLL);

	double comctl32 = GetFileVersion("comctl32.dll");
	if( comctl32 >= 470 ){
		long dwStyle = ListView_GetExtendedListViewStyle(m_DllSubList.m_hWnd);
		dwStyle |=	LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
		ListView_SetExtendedListViewStyle(m_DllSubList.m_hWnd, dwStyle);
	}
	if( comctl32 >= 471 ){
		m_DllSubList.GetHeaderCtrl()->EnableWindow(FALSE);
	}
	m_DllSubList.InsertColumn(0,"Dll Name",LVCFMT_LEFT,width * 18 / 100,0);
	m_DllSubList.InsertColumn(1,"Version Information",LVCFMT_LEFT,width * 45 / 100,0);
	m_DllSubList.InsertColumn(2,"Description",LVCFMT_LEFT,width * 37 / 100,0);
	SelectTab(0);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDllSubDlg::SelectTab(int id)
{
	m_DllSubList.DeleteAllItems();

	CString unit;
	LVITEM myItem;
	memset(&myItem,0,sizeof(LVITEM));
	myItem.mask = LVIF_TEXT;
	char** DllList;
	
	static char* DllWindows[] = {
		"kernel32.dll","KERNEL",
		"user32.dll","USER",
		"gdi32.dll","GDI",
		"gdiplus.dll","GDI+",
		"ntdll.dll","NT Layer",
		"ole32.dll","OLE",
		"oleaut32.dll","OLEAUT",
		"comctl32.dll","Common Cntrol",
		"comdlg32.dll","Common Dialog",
		"wininet.dll","Internet Extensions",
		"UxTheme.dll","UxTheme (Luna)",
		"mscoree.dll",".NET Framework Core",
		"msi.dll","Windows Installer",
		"msimg32.dll","GDIEXT Client",
//		"winsock.dll","Windows Socket 16bit",
		"wsock32.dll","Windows Socket",
		"opengl32.dll","OpenGL",
		"glu32.dll","OpenGL Utility",
//		"glut32.dll","GLUT",
		"","",
	};

	static char* DllVisualC[] = {
		"msvcrt.dll","Shared C Runtime",
		"msvcrt20.dll","C Runtime",
		"msvcrt40.dll","C Runtime Forwarder",
		"msvcr70.dll","C Runtime",
		"msvcp50.dll","C++ Runtime",
		"msvcp60.dll","C++ Runtime",
		"msvcp70.dll","C++ Runtime",
		"msvcp71.dll","C++ Runtime",
//		"msvcp80.dll","C++ Runtime",
		"mfc30.dll","MFC 3.0",
		"mfc40.dll","MFC 4.0",
		"mfc42.dll","MFC 4.2/5.0/6.0",
		"mfc70.dll","MFC 7.0",
		"mfc71.dll","MFC 7.1",
		"","",
	};

	static char* DllVisualBasic[] = {
//		"vb40016.dll","Visual Basic Runtime 4.0 (16bit)",
		"vb40032.dll","Visual Basic Runtime 4.0",
		"msvbvm50.dll","Visual Basic Runtime 5.0",
		"msvbvm60.dll","Visual Basic Runtime 6.0",
		"","",
	};

	static char* DllArchiver[] = {
		"unlha32.dll","lzh",
		"unzip32.dll","zip",
		"cab32.dll","cab",
		"tar32.dll","tar / tar.gz / tgz / Z ...",
//		"unrar.dll","rar",
		"unrar32.dll","rar",
		"ungca32.dll","gca",
		"unarj32j.dll","arj",
		"7-zip32.dll","7z / zip",
		"yz1.dll","yz",
		"unyz1.dll","yz",
		"","",
	};

	switch (id)
	{
	case 0: DllList = DllWindows; break;
	case 1: DllList = DllVisualC; break;
	case 2: DllList = DllVisualBasic; break;
	case 3: DllList = DllArchiver; break;
	default:DllList = DllWindows;break;
	}

	char str[256];
	char version[256];
	CString cstr;
	for(int i=0; strcmp(DllList[i],"") != 0 ;i+=2){
		strcpy(version,"");
		int major=0,minor=0,revision=0,build=0;
		GetFileVersion(DllList[i],version);
		if( strcmp(version,"") != 0 ){
			strcpy(str,version);
		}else{
			if(strcmp(DllList[i],"") != 0){
				strcpy(str,"Not Installed");
			}else{
				strcpy(str,"");
			}
		}
		myItem.iItem = i / 2;
		myItem.iSubItem = 0;
		myItem.pszText = DllList[i];
		m_DllSubList.InsertItem(&myItem);
		myItem.iSubItem = 1;
		myItem.pszText = str;
		m_DllSubList.SetItem(&myItem);
		myItem.iSubItem = 2;
		myItem.pszText = DllList[i+1];
		m_DllSubList.SetItem(&myItem);
	}
}
/*
HBRUSH CDllSubDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if( gFlagBack ){
		switch (nCtlColor)
		{
			case CTLCOLOR_BTN:
			case CTLCOLOR_STATIC:
			{
				pDC->SetBkMode(TRANSPARENT);
				return (HBRUSH)GetStockObject(HOLLOW_BRUSH);
			}
			case CTLCOLOR_EDIT:
			case CTLCOLOR_DLG:
			{
				return (HBRUSH)gBackBrush;
			}
		}
	}

	return hbr;
}
*/