// PCIDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CrystalMark.h"
#include "CrystalMarkDlg.h"
#include "PCIDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPCIDialog _CAO


CPCIDlg::CPCIDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPCIDlg::IDD, pParent)
{
	SysInfo = ((CCrystalMarkDlg*)pParent)->SysInfo;
	//{{AFX_DATA_INIT(CPCIDlg)
	m_PciClassID = _T("");
	m_PciDeviceID = _T("");
	m_PciDeviceName = _T("");
	m_PciRevision = _T("");
	m_PciBus = _T("");
	m_PciClassName = _T("");
	m_PciDevice = _T("");
	m_PciFunction = _T("");
	m_PciSubSystemID = _T("");
	m_PciSubSystemName = _T("");
	m_PciVendorID = _T("");
	m_PciVendorName = _T("");
	//}}AFX_DATA_INIT
}


void CPCIDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPCIDlg)
	DDX_Control(pDX, IDC_PCI_VENDOR_NAME, m_PciVendorNameC);
	DDX_Control(pDX, IDC_PCI_VENDOR_ID, m_PciVendorIDC);
	DDX_Control(pDX, IDC_PCI_SUB_SYSTEM_NAME, m_PciSubSystemNameC);
	DDX_Control(pDX, IDC_PCI_SUB_SYSTEM_ID, m_PciSubSystemIDC);
	DDX_Control(pDX, IDC_PCI_FUNCTION, m_PciFunctionC);
	DDX_Control(pDX, IDC_PCI_DEVICE, m_PciDeviceC);
	DDX_Control(pDX, IDC_PCI_CLASS_NAME, m_PciClassNameC);
	DDX_Control(pDX, IDC_PCI_BUS, m_PciBusC);
	DDX_Control(pDX, IDC_PCI__REVISION, m_PciRevisionC);
	DDX_Control(pDX, IDC_PCI__DEVICE_NAME, m_PciDeviceNameC);
	DDX_Control(pDX, IDC_PCI__DEVICE_ID, m_PciDeviceIDC);
	DDX_Control(pDX, IDC_PCI__CLASS_ID, m_PciClassIDC);
	DDX_Control(pDX, IDC_PCI_LIST, m_PciList);
	DDX_Text(pDX, IDC_PCI__CLASS_ID, m_PciClassID);
	DDX_Text(pDX, IDC_PCI__DEVICE_ID, m_PciDeviceID);
	DDX_Text(pDX, IDC_PCI__DEVICE_NAME, m_PciDeviceName);
	DDX_Text(pDX, IDC_PCI__REVISION, m_PciRevision);
	DDX_Text(pDX, IDC_PCI_BUS, m_PciBus);
	DDX_Text(pDX, IDC_PCI_CLASS_NAME, m_PciClassName);
	DDX_Text(pDX, IDC_PCI_DEVICE, m_PciDevice);
	DDX_Text(pDX, IDC_PCI_FUNCTION, m_PciFunction);
	DDX_Text(pDX, IDC_PCI_SUB_SYSTEM_ID, m_PciSubSystemID);
	DDX_Text(pDX, IDC_PCI_SUB_SYSTEM_NAME, m_PciSubSystemName);
	DDX_Text(pDX, IDC_PCI_VENDOR_ID, m_PciVendorID);
	DDX_Text(pDX, IDC_PCI_VENDOR_NAME, m_PciVendorName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPCIDlg, CDialog)
	//{{AFX_MSG_MAP(CPCIDlg)
	ON_NOTIFY(NM_CLICK, IDC_PCI_LIST, OnClickPciList)
//	ON_NOTIFY(LVN_KEYDOWN, IDC_PCI_LIST, OnKeydownPciList)
	ON_WM_CTLCOLOR()
	ON_NOTIFY(NM_RETURN, IDC_PCI_LIST, OnReturnPciList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPCIDialog bZ[W nh

BOOL CPCIDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

// Xgr[̍\z
	LVCOLUMN myColumn;
	myColumn.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_ORDER ;
	char str[256];

	// Rg[̕擾
	CRect cr;m_PciList.GetClientRect(cr);
	DWORD width = cr.Width() - GetSystemMetrics(SM_CXVSCROLL);

	double comctl32 = GetFileVersion("comctl32.dll");
	if( comctl32 >= 470 ){
		long dwStyle = ListView_GetExtendedListViewStyle(m_PciList.m_hWnd);
		dwStyle |=	LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
		ListView_SetExtendedListViewStyle(m_PciList.m_hWnd, dwStyle);
	}
	if( comctl32 >= 471 ){
		m_PciList.GetHeaderCtrl()->EnableWindow(FALSE);
	}
	if( comctl32 >= 470 ){
		m_PciList.InsertColumn(0,"",LVCFMT_LEFT,0);
		m_PciList.InsertColumn(1,"Bus",LVCFMT_CENTER,width * 35 / 555);
	}else{
		m_PciList.InsertColumn(0,"Bus",LVCFMT_LEFT,width * 35 / 555);
		m_PciList.InsertColumn(1,"",LVCFMT_LEFT,0);
	}
	m_PciList.InsertColumn(2,"Dev",LVCFMT_CENTER,width * 35 / 555);
	m_PciList.InsertColumn(3,"Fnc",LVCFMT_CENTER,width * 35 / 555);
	m_PciList.InsertColumn(4,"Vendor",LVCFMT_CENTER,width * 55 / 555);
	m_PciList.InsertColumn(5,"Device",LVCFMT_CENTER,width * 55 / 555);
	m_PciList.InsertColumn(6,"Rev",LVCFMT_CENTER,width * 35 / 555);
	m_PciList.InsertColumn(7,"SubSystem",LVCFMT_CENTER,width * 80 / 555);
	m_PciList.InsertColumn(8,"Class",LVCFMT_CENTER,width * 65 / 555);
	m_PciList.InsertColumn(9,"Device Type",LVCFMT_LEFT,width * 160 / 555);
	m_PciList.InsertColumn(10,"Vendor Name",LVCFMT_LEFT,0);
	m_PciList.InsertColumn(11,"Device Name",LVCFMT_LEFT,0);
	m_PciList.InsertColumn(12,"Sub Vendor Name",LVCFMT_LEFT,0);

	DWORD data1,data2,data3,data4;
	DWORD NumberOfDevice;
	CString cstr;
	LVITEM myItem;
	memset(&myItem,0,sizeof(LVITEM));
	myItem.mask = LVIF_TEXT;

	SysInfo->GetData(PCI_NUMBER_OF_DEVICE,&NumberOfDevice);
	for(DWORD i=0;i < NumberOfDevice;i++){
		myItem.iItem = i;
		SysInfo->GetData(PCI_PCI_BUS_BASE + i,&data1);
		myItem.iSubItem = 0;wsprintf(str,"%d",data1);myItem.pszText = str;m_PciList.InsertItem(&myItem);
		myItem.iSubItem = 1;wsprintf(str,"%d",data1);myItem.pszText = str;m_PciList.SetItem(&myItem);
		SysInfo->GetData(PCI_PCI_DEVICE_BASE + i,&data2);
		myItem.iSubItem = 2;wsprintf(str,"%d",data2);myItem.pszText = str;m_PciList.SetItem(&myItem);
		SysInfo->GetData(PCI_PCI_FUNCTION_BASE + i,&data3);
		myItem.iSubItem = 3;wsprintf(str,"%d",data3);myItem.pszText = str;m_PciList.SetItem(&myItem);
		//wsprintf(str,"%1d:%2d:%1d ",data1,data2,data3);cstr += str;
		
		SysInfo->GetData(PCI_VENDOR_ID_BASE + i,&data1);
		myItem.iSubItem = 4;wsprintf(str,"%04Xh",data1);myItem.pszText = str;m_PciList.SetItem(&myItem);
		SysInfo->GetData(PCI_DEVICE_ID_BASE + i,&data2);
		myItem.iSubItem = 5;wsprintf(str,"%04Xh",data2);myItem.pszText = str;m_PciList.SetItem(&myItem);
		SysInfo->GetData(PCI_REVISION_ID_BASE + i,&data3);
		myItem.iSubItem = 6;wsprintf(str,"%02Xh",data3);myItem.pszText = str;m_PciList.SetItem(&myItem);
		SysInfo->GetData(PCI_SUBSYSTEM_ID_BASE + i,&data4);
		myItem.iSubItem = 7;wsprintf(str,"%08Xh",data4);myItem.pszText = str;m_PciList.SetItem(&myItem);
		//wsprintf(str,"%04X%04X:%02X <%08X> ",data1,data2,data3,data4);cstr += str;

		SysInfo->GetData(PCI_CLASS_ID_BASE + i,&data1);
		myItem.iSubItem = 8;wsprintf(str,"%06Xh",data1);myItem.pszText = str;m_PciList.SetItem(&myItem);
		//wsprintf(str,"| %06X ",data1);cstr += str;
		SysInfo->GetString(PCI_CLASS_NAME_BASE + i,str);
		myItem.iSubItem = 9;wsprintf(str,"%s",str);myItem.pszText = str;m_PciList.SetItem(&myItem);

		SysInfo->GetString(PCI_VENDOR_NAME_BASE + i,str);
		myItem.iSubItem = 10;wsprintf(str,"%s",str);myItem.pszText = str;m_PciList.SetItem(&myItem);
		SysInfo->GetString(PCI_DEVICE_NAME_BASE + i,str);
		myItem.iSubItem = 11;wsprintf(str,"%s",str);myItem.pszText = str;m_PciList.SetItem(&myItem);
		SysInfo->GetString(PCI_SUB_VENDOR_NAME_BASE + i,str);
		myItem.iSubItem = 12;wsprintf(str,"%s",str);myItem.pszText = str;m_PciList.SetItem(&myItem);
		
		//cstr += str;cstr += "\r\n";
	}
	m_hotItem = 0;
	m_NumberOfItem = NumberOfDevice;
	SetPciDetailInfo(0);
	m_PciList.SetItemState(0, LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED|LVIS_FOCUSED );

	return TRUE;
}

void CPCIDlg::OnClickPciList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	//NbNW擾
	DWORD dwPos = ::GetMessagePos();
	CPoint point ((int)LOWORD(dwPos),(int)HIWORD(dwPos));
	m_PciList.ScreenToClient(&point);

	m_hotItem = m_PciList.HitTest(point);
	SetPciDetailInfo(m_hotItem);

	*pResult = 0;
}

/*
void CPCIDlg::OnKeydownPciList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDown = (LV_KEYDOWN*)pNMHDR;
	if(pLVKeyDown->wVKey == VK_RETURN){
	}
	m_hotItem = m_PciList.GetNextItem( -1, LVNI_ALL | LVNI_SELECTED);
	SetPciDetailInfo(m_hotItem);

	*pResult = 0;
}
*/
void CPCIDlg::SetPciDetailInfo(DWORD hotItem) 
{
	if(0 <= hotItem && hotItem < m_NumberOfItem){ 
		CString cstr;
		m_PciBus = m_PciList.GetItemText(hotItem,1);
		m_PciDevice = m_PciList.GetItemText(hotItem,2);
		m_PciFunction = m_PciList.GetItemText(hotItem,3);
		m_PciVendorID = m_PciList.GetItemText(hotItem,4);
		m_PciDeviceID = m_PciList.GetItemText(hotItem,5);
		m_PciRevision = m_PciList.GetItemText(hotItem,6);
		m_PciSubSystemID = m_PciList.GetItemText(hotItem,7);
		m_PciClassID = m_PciList.GetItemText(hotItem,8);
		m_PciClassName = " " + m_PciList.GetItemText(hotItem,9);
		m_PciVendorName = " " + m_PciList.GetItemText(hotItem,10);
		m_PciDeviceName = " " + m_PciList.GetItemText(hotItem,11);
		m_PciSubSystemName = " " + m_PciList.GetItemText(hotItem,12);
		m_PciList.SetSelectionMark(hotItem);

		UpdateData(FALSE);

		if( gFlagBack ){
			m_PciBusC.ShowWindow(SW_HIDE);
			m_PciBusC.ShowWindow(SW_SHOW);
			m_PciDeviceC.ShowWindow(SW_HIDE);
			m_PciDeviceC.ShowWindow(SW_SHOW);
			m_PciFunctionC.ShowWindow(SW_HIDE);
			m_PciFunctionC.ShowWindow(SW_SHOW);
			m_PciVendorIDC.ShowWindow(SW_HIDE);
			m_PciVendorIDC.ShowWindow(SW_SHOW);
			m_PciDeviceIDC.ShowWindow(SW_HIDE);
			m_PciDeviceIDC.ShowWindow(SW_SHOW);
			m_PciRevisionC.ShowWindow(SW_HIDE);
			m_PciRevisionC.ShowWindow(SW_SHOW);
			m_PciSubSystemIDC.ShowWindow(SW_HIDE);
			m_PciSubSystemIDC.ShowWindow(SW_SHOW);
			m_PciClassIDC.ShowWindow(SW_HIDE);
			m_PciClassIDC.ShowWindow(SW_SHOW);
			m_PciClassNameC.ShowWindow(SW_HIDE);
			m_PciClassNameC.ShowWindow(SW_SHOW);
			m_PciVendorNameC.ShowWindow(SW_HIDE);
			m_PciVendorNameC.ShowWindow(SW_SHOW);
			m_PciDeviceNameC.ShowWindow(SW_HIDE);
			m_PciDeviceNameC.ShowWindow(SW_SHOW);
			m_PciSubSystemNameC.ShowWindow(SW_HIDE);
			m_PciSubSystemNameC.ShowWindow(SW_SHOW);
		}
	}
}

HBRUSH CPCIDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if( gFlagBack ){
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
				return (HBRUSH)GetStockObject(HOLLOW_BRUSH);
			}
			case CTLCOLOR_DLG:
			{
				return (HBRUSH)gBackBrush;
			}
		}
	}else{
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
			}
		}
	}

	return hbr;
}
/**/

void CPCIDlg::OnReturnPciList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	MessageBox("");
	LV_KEYDOWN* pLVKeyDown = (LV_KEYDOWN*)pNMHDR;
	if(pLVKeyDown->wVKey == VK_RETURN){
	}
	m_hotItem = m_PciList.GetNextItem( -1, LVNI_ALL | LVNI_SELECTED);
	SetPciDetailInfo(m_hotItem);

	*pResult = 0;
}

void CPCIDlg::OnOK() 
{
	m_hotItem = m_PciList.GetNextItem( -1, LVNI_ALL | LVNI_SELECTED);
	SetPciDetailInfo(m_hotItem);
//	CDialog::OnOK();
}

void CPCIDlg::OnCancel() 
{
//	CDialog::OnCancel();
}
