// SystemDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CrystalMark.h"
#include "CrystalMarkDlg.h"
#include "SystemDlg.h"
#include "Share.h"
#include "../common/GetOSInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSystemDlg _CAO


CSystemDlg::CSystemDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSystemDlg::IDD, pParent)
{
	SysInfo = ((CCrystalMarkDlg*)pParent)->SysInfo;

	//{{AFX_DATA_INIT(CSystemDlg)
	m_SysOSCaption = _T("");
	m_SysOSCSDVersion = _T("");
	m_SysOSInstallDate = _T("");
	m_SysOSVersion = _T("");
	m_SysMachineName = _T("");
	m_SysUserName = _T("");
	m_SysPageSize = _T("");
	m_SysMinAppAddress = _T("");
	m_SysMaxAppAddress = _T("");
	m_SysSystemDirectory = _T("");
	m_SysWindowsDirectory = _T("");
	m_SysMemAvailPhys = _T("");
	m_SysMemAvailVirtual = _T("");
	m_SysMemLoadPhys = _T("");
	m_SysMemLoadVirtual = _T("");
	m_SysMemTotalPhys = _T("");
	m_SysMemTotalVirtual = _T("");
	m_SysMemAvailPagefile = _T("");
	m_SysMemPagefileLoad = _T("");
	m_SysMemVirtualLoad = _T("");
	m_SysMemTotalPagefile = _T("");
	m_SysBiosCaption = _T("");
	m_SysBiosDate = _T("");
	m_SysBiosManufacturer = _T("");
	m_SysBiosVersion = _T("");
	m_SysMotherManufacturer = _T("");
	m_SysMotherProduct = _T("");
	m_SysMotherVersion = _T("");
	m_SysBiosSMBiosVersion = _T("");
	m_SysSystemManufacturer = _T("");
	m_SysSystemModel = _T("");
	m_SysBiosSMVersion = _T("");
	m_SysCurrentTime = _T("");
	m_SysWindowsTime = _T("");
	//}}AFX_DATA_INIT
}


void CSystemDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSystemDlg)
	DDX_Control(pDX, IDC_SYS_MEM_TOTAL_PAGEFILE, m_SysMemTotalPagefileC);
	DDX_Control(pDX, IDC_SYS_MEM_TOTAL_VIRTUAL, m_SysMemTotalVirtualC);
	DDX_Control(pDX, IDC_SYS_MEM_VIRTUAL_LOAD, m_SysMemVirtualLoadC);
	DDX_Control(pDX, IDC_SYS_CURRENT_TIME, m_SysCurrentTimeC);
	DDX_Control(pDX, IDC_SYS_WINDOWS_TIME, m_SysWindowsTimeC);
	DDX_Control(pDX, IDC_SYS_MEM_TOTAL_PHYS, m_SysMemTotalPhysC);
	DDX_Control(pDX, IDC_SYS_MEM_PHYS_LOAD, m_SysMemPhysLoadC);
	DDX_Control(pDX, IDC_SYS_MEM_PAGEFILE_LOAD, m_SysMemPagefileLoadC);
	DDX_Control(pDX, IDC_SYS_MEM_AVAIL_VIRTUAL, m_SysMemAvailVirtualC);
	DDX_Control(pDX, IDC_SYS_MEM_AVAIL_PHYS, m_SysMemAvailPhysC);
	DDX_Control(pDX, IDC_SYS_MEM_AVAIL_PAGEFILE, m_SysMemAvailPagefileC);
	DDX_Text(pDX, IDC_SYS_MEM_PHYS_LOAD, m_SysMemPhysLoad);
	DDX_Text(pDX, IDC_SYS_OS_CAPTION, m_SysOSCaption);
	DDX_Text(pDX, IDC_SYS_OS_CSD_VERSION, m_SysOSCSDVersion);
	DDX_Text(pDX, IDC_SYS_OS_INSTALL_DATE, m_SysOSInstallDate);
	DDX_Text(pDX, IDC_SYS_OS_VERSION, m_SysOSVersion);
	DDX_Text(pDX, IDC_SYS_MACHINE_NAME, m_SysMachineName);
	DDX_Text(pDX, IDC_SYS_USER_NAME, m_SysUserName);
	DDX_Text(pDX, IDC_SYS_PAGE_SIZE, m_SysPageSize);
	DDX_Text(pDX, IDC_SYS_MIN_APP_ADDRESS, m_SysMinAppAddress);
	DDX_Text(pDX, IDC_SYS_MAX_APP_ADDRESS, m_SysMaxAppAddress);
	DDX_Text(pDX, IDC_SYS_SYSTEM_DIRECTORY, m_SysSystemDirectory);
	DDX_Text(pDX, IDC_SYS_WINDOWS_DIRECTORY, m_SysWindowsDirectory);
	DDX_Text(pDX, IDC_SYS_MEM_AVAIL_PHYS, m_SysMemAvailPhys);
	DDX_Text(pDX, IDC_SYS_MEM_AVAIL_VIRTUAL, m_SysMemAvailVirtual);
	DDX_Text(pDX, IDC_SYS_MEM_TOTAL_PHYS, m_SysMemTotalPhys);
	DDX_Text(pDX, IDC_SYS_MEM_TOTAL_VIRTUAL, m_SysMemTotalVirtual);
	DDX_Text(pDX, IDC_SYS_MEM_AVAIL_PAGEFILE, m_SysMemAvailPagefile);
	DDX_Text(pDX, IDC_SYS_MEM_PAGEFILE_LOAD, m_SysMemPagefileLoad);
	DDX_Text(pDX, IDC_SYS_MEM_VIRTUAL_LOAD, m_SysMemVirtualLoad);
	DDX_Text(pDX, IDC_SYS_MEM_TOTAL_PAGEFILE, m_SysMemTotalPagefile);
	DDX_Text(pDX, IDC_SYS_BIOS_CAPTION, m_SysBiosCaption);
	DDX_Text(pDX, IDC_SYS_BIOS_DATE, m_SysBiosDate);
	DDX_Text(pDX, IDC_SYS_BIOS_MANUFACTURER, m_SysBiosManufacturer);
	DDX_Text(pDX, IDC_SYS_BIOS_VERSION, m_SysBiosVersion);
	DDX_Text(pDX, IDC_SYS_MOTHER_MANUFACTURER, m_SysMotherManufacturer);
	DDX_Text(pDX, IDC_SYS_MOTHER_PRODUCT, m_SysMotherProduct);
	DDX_Text(pDX, IDC_SYS_MOTHER_VERSION, m_SysMotherVersion);
	DDX_Text(pDX, IDC_SYS_BIOS_SM_BIOS_VERSION, m_SysBiosSMBiosVersion);
	DDX_Text(pDX, IDC_SYS_SYSTEM_MANUFACTURER, m_SysSystemManufacturer);
	DDX_Text(pDX, IDC_SYS_SYSTEM_MODEL, m_SysSystemModel);
	DDX_Text(pDX, IDC_SYS_BIOS_SM_VERSION, m_SysBiosSMVersion);
	DDX_Text(pDX, IDC_SYS_CURRENT_TIME, m_SysCurrentTime);
	DDX_Text(pDX, IDC_SYS_WINDOWS_TIME, m_SysWindowsTime);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSystemDlg, CDialog)
	//{{AFX_MSG_MAP(CSystemDlg)
	ON_WM_SHOWWINDOW()
	ON_WM_TIMER()
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSystemDlg bZ[W nh

void CSystemDlg::OnOK() 
{
//	CDialog::OnOK();
}

void CSystemDlg::OnCancel() 
{
//	CDialog::OnCancel();
}

// ^p
void SysGetS(DWORD ID,CString& C,ISysInfo* SysInfo)
{
	char str[1024];
	SysInfo->GetString(ID,str);
	C = str;
}

static void GetProcessorArchitecture(WORD pa,WORD pl,CString& PA);

BOOL CSystemDlg::OnInitDialog() 
{
	char str[1024];
	DWORD length;
//	DWORD data;
	CString cstr;

	CDialog::OnInitDialog();

	CString OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo;
	GetOSInfo(OSName,OSType,OSCSD,OSVersion,OSBuild,OSInfo);
	m_SysOSCaption = " " + OSName + " " + OSType;
	m_SysOSCSDVersion = " " + OSCSD;
	m_SysOSVersion = " " + OSVersion + " Build " + OSBuild;

	length = 1024;if( GetUserName(str,&length) ){m_SysUserName = " ";m_SysUserName += str;}
	length = 1024;if( GetComputerName(str,&length) ){m_SysMachineName = " ";m_SysMachineName += str;}
	GetSystemDirectory(str,MAX_PATH);m_SysSystemDirectory = " ";m_SysSystemDirectory += str;
	GetWindowsDirectory(str,MAX_PATH);m_SysWindowsDirectory = " ";m_SysWindowsDirectory += str;

	SYSTEM_INFO si;
	GetSystemInfo(&si);
	m_SysPageSize.Format("%d",si.dwPageSize);
	m_SysMaxAppAddress.Format("0x%08X",si.lpMaximumApplicationAddress);
	m_SysMinAppAddress.Format("0x%08X",si.lpMinimumApplicationAddress);

	return TRUE;
}

static void GetProcessorArchitecture(WORD pa,WORD pl,CString& PA)
{
	switch(pa)
	{
	case PROCESSOR_ARCHITECTURE_INTEL:
		PA = "Intel Architecture (IA32)";
		break;
	case PROCESSOR_ARCHITECTURE_MIPS:
		PA = "MIPS Architecture";
		break;
	case PROCESSOR_ARCHITECTURE_ALPHA:
		PA = "Alpha Architecture";
		switch(pl){
		case 21064:PA += " (Alpha 21064)";break;
		case 21066:PA += " (Alpha 21066)";break;
		case 21164:PA += " (Alpha 21164)";break;
		}
		break;
	case PROCESSOR_ARCHITECTURE_PPC:
		PA = "PowerPC Architecture";
		switch(pl){
		case 1:	PA += " (PowerPC 601)";break;
		case 3:	PA += " (PowerPC 603)";break;
		case 4:	PA += " (PowerPC 604)";break;
		case 6:	PA += " (PowerPC 603+)";break;
		case 9:	PA += " (PowerPC 604+)";break;
		case 20:PA += " (PowerPC 620)";break;
		}
		break;
	case PROCESSOR_ARCHITECTURE_IA64:
		PA = "Intel Architecture (IA64)";break;
	case PROCESSOR_ARCHITECTURE_AMD64:
		PA = "AMD Architecture (AA64)";break;
	default:
		PA = "Unknown Architecture";break;
	}
}

void CSystemDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	static int TimerID = 1;
	if(bShow == TRUE){
//		MessageBox("SHOW");
		TimerID = SetTimer(1,100,0);
	}else{
//		MessageBox("HIDE");
		KillTimer(TimerID);
	}
}

void UpdateLabel(CStatic& cs,CString& str,double data);

void UpdateLabel(CStatic& cs,CString& str,double data)
{
	CString cstr;
	cstr.Format("%.2f",data);
	if( cstr != str){
		str = cstr;
		if(gFlagBack){
			cs.ShowWindow(SW_HIDE);
			cs.ShowWindow(SW_SHOW);
		}
	}
}

void CSystemDlg::OnTimer(UINT nIDEvent) 
{
	// gp
	MEMORYSTATUS MemStatus;
	GlobalMemoryStatus(&MemStatus);
/*
	cstr.Format("%.2f",(double)MemStatus.dwTotalPhys / 1024 / 1024);
	if( cstr != m_SysMemTotalPhys ){
		m_SysMemTotalPhys = cstr;
		m_SysMemTotalPhysC.ShowWindow(SW_HIDE);
		m_SysMemTotalPhysC.ShowWindow(SW_SHOW);
	}
	m_SysMemAvailPhysC.SetString(m_SysMemAvailPhys);
*/
	CString cstr;
	UpdateLabel(m_SysMemTotalPhysC,m_SysMemTotalPhys,(double)MemStatus.dwTotalPhys / 1024 / 1024);
	UpdateLabel(m_SysMemAvailPhysC,m_SysMemAvailPhys,(double)MemStatus.dwAvailPhys / 1024 / 1024);
	UpdateLabel(m_SysMemTotalPagefileC,m_SysMemTotalPagefile,(double)MemStatus.dwTotalPageFile / 1024 / 1024);
	UpdateLabel(m_SysMemAvailPagefileC,m_SysMemAvailPagefile,(double)MemStatus.dwAvailPageFile / 1024 / 1024);
	UpdateLabel(m_SysMemTotalVirtualC,m_SysMemTotalVirtual,(double)MemStatus.dwTotalVirtual / 1024 / 1024);
	UpdateLabel(m_SysMemAvailVirtualC,m_SysMemAvailVirtual,(double)MemStatus.dwAvailVirtual / 1024 / 1024);
	UpdateLabel(m_SysMemPhysLoadC,m_SysMemPhysLoad,(double)(MemStatus.dwAvailPhys / (double)MemStatus.dwTotalPhys * 100) / 1.0);
	UpdateLabel(m_SysMemPagefileLoadC,m_SysMemPagefileLoad,(double)(MemStatus.dwAvailPageFile / (double)MemStatus.dwTotalPageFile * 100) / 1.0);
	UpdateLabel(m_SysMemVirtualLoadC,m_SysMemVirtualLoad,(double)(MemStatus.dwAvailVirtual / (double)MemStatus.dwTotalVirtual * 100) / 1.0);
//	

	// Time ̐ݒ
	SYSTEMTIME st;
	GetLocalTime(&st);

	cstr.Format("%04d/%02d/%02d %d:%02d:%02d",st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
	if( cstr != m_SysCurrentTime )
	{
		m_SysCurrentTime = cstr;
		if(gFlagBack){
			m_SysCurrentTimeC.ShowWindow(SW_HIDE);
			m_SysCurrentTimeC.ShowWindow(SW_SHOW);
		}
	}
	
	DWORD tc;
	DWORD h,m,s;
	tc = GetTickCount() / 1000;
	h = tc / 60 / 60;
	m = tc / 60 % 60;
	s = tc % 60 % 60;

	cstr.Format("%d h %02d m %02d s", h, m, s );
	if( cstr != m_SysWindowsTime )
	{
		m_SysWindowsTime = cstr;
		if(gFlagBack){
			m_SysWindowsTimeC.ShowWindow(SW_HIDE);
			m_SysWindowsTimeC.ShowWindow(SW_SHOW);
		}
	}
/*  gpgX^C
	CString cstr;
	SysInfo->GetData(WIN_MEM_PHYS_LOAD,&data);
	cstr.Format("%0.2f %%",data / 100.0);
	m_SysMemPhysLoad.SetWidth((int)(data / 100.0 /100.0 * 256.0 ));
	m_SysMemPhysLoad.SetString(cstr);
*/
	UpdateData(FALSE);
	
	CDialog::OnTimer(nIDEvent);
}

HBRUSH CSystemDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if( gFlagBack ){
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
				return (HBRUSH)GetStockObject(HOLLOW_BRUSH);
			}
			case CTLCOLOR_DLG:
			{
				return (HBRUSH)gBackBrush;
			}
		}
	}else{
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
			}
		}
	}

	return hbr;
}

/*
	SysInfo.dll W -> R73 p~ 2003/3/6 

	SysInfo->GetData(WIN_MEM_INFO_UPDATE,&data);
	SysInfo->GetData(WIN_MEM_TOTAL_PHYS,&data);			m_SysMemTotalPhys.Format("%.2f MB",(double)data / 1024 / 1024);
	SysInfo->GetData(WIN_MEM_AVAIL_PHYS,&data);			m_SysMemAvailPhys.Format("%.2f MB",(double)data / 1024 / 1024);
	SysInfo->GetData(WIN_MEM_TOTAL_PAGEFILE,&data);		m_SysMemTotalPagefile.Format("%.2f MB",(double)data / 1024 / 1024);
	SysInfo->GetData(WIN_MEM_AVAIL_PAGEFILE,&data);		m_SysMemAvailPagefile.Format("%.2f MB",(double)data / 1024 / 1024);
	SysInfo->GetData(WIN_MEM_TOTAL_VIRTUAL,&data);		m_SysMemTotalVirtual.Format("%.2f MB",(double)data / 1024 / 1024);
	SysInfo->GetData(WIN_MEM_AVAIL_VIRTUAL,&data);		m_SysMemAvailVirtual.Format("%.2f MB",(double)data / 1024 / 1024);
	SysInfo->GetData(WIN_MEM_PHYS_LOAD,&data);			m_SysMemPhysLoad.Format("%0.2f %%",data / 100.0);
	SysInfo->GetData(WIN_MEM_PAGEFILE_LOAD,&data);		m_SysMemPagefileLoad.Format("%0.2f %%",data / 100.0);
	SysInfo->GetData(WIN_MEM_VIRTUAL_LOAD,&data);		m_SysMemVirtualLoad.Format("%0.2f %%",data / 100.0);
*/
