#include "stdafx.h"
#include "CrystalMark.h"
#include "CrystalMarkDlg.h"
#include "wbemcli.h"     // WMI interface declarations

#include "resource.h"

#include <process.h>

#include "../SysInfo/ISysInfo.h"
#include "../SysInfo/ItemID.h"
#include "Share.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

typedef HRESULT(WINAPI * _CoInitializeSecurity_)(PSECURITY_DESCRIPTOR pVoid,LONG cAuthSvc,SOLE_AUTHENTICATION_SERVICE * asAuthSvc,void * pReserved1,
DWORD dwAuthnLevel,DWORD dwImpLevel,SOLE_AUTHENTICATION_LIST * pAuthList,DWORD dwCapabilities,void * pReserved3);

UINT WMIInit(LPVOID Status)
//void WMIInit(void* Status)
{
	CCrystalMarkDlg* Dlg= (CCrystalMarkDlg*)Status;

	try{
// ̓x`s
#ifndef CRYSTAL_SYS_INFO
	Dlg->m_MarkDlg->ChangeAllWindowStatus(FALSE,FALSE);
#endif
	Dlg->SetWindowTitle("- Now WMI Initializing...");
	
	DebugInfo(WMI_INIT_START);

	HRESULT hRes = S_OK;
	ULONG   uReturned = 1;
	CString cstr;
	char text[256];
	strcpy(text,"");

	OSVERSIONINFOEX osvi;
	BOOL bOsVersionInfoEx;
	ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
	if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
	{
		osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
		GetVersionEx( (OSVERSIONINFO *) &osvi);
	}

	IWbemLocator *pIWbemLocator = NULL;
	IWbemServices* pIWbemServices = NULL;
	IEnumWbemClassObject *pEnumCOMDevs = NULL;
	IWbemClassObject  *pCOMDev = NULL;

	if(CoInitialize( NULL ) != S_OK){return 1;}

	_CoInitializeSecurity_ CoInitializeSecurity = NULL;
	HINSTANCE hDLL = LoadLibrary( "ole32.dll" );
	if(  hDLL != NULL ){
		CoInitializeSecurity = (_CoInitializeSecurity_)GetProcAddress( hDLL, "CoInitializeSecurity" );
	}
	if(CoInitializeSecurity == NULL){
		FreeLibrary(hDLL);
		return 1;
	}
	CoInitializeSecurity(NULL, -1, NULL, NULL,
		RPC_C_AUTHN_LEVEL_PKT_PRIVACY,RPC_C_IMP_LEVEL_IMPERSONATE,
		NULL,EOAC_SECURE_REFS,NULL );
	FreeLibrary(hDLL);

	if( CoCreateInstance(CLSID_WbemLocator,NULL,
		CLSCTX_INPROC_SERVER,IID_IWbemLocator,
		(LPVOID *) &pIWbemLocator) != S_OK ){return 1;}
	if( pIWbemLocator->ConnectServer(SysAllocString(L"\\\\.\\root\\cimv2"),
		NULL,NULL,0L,0L,NULL,NULL,&pIWbemServices) != S_OK ){return 1;}
	pIWbemLocator->Release();

/////////////////
//Disk
	if( CheckWMIFlag("DisableWMI_DISK") == 0 ){

		try{
		DebugInfo("Disk");
		// IDE foCX̐mF
		// ȂȂ SCSI foCXɌĂfoCX邩Ȃ
		static DWORD FlagSafeMode = CheckSafeMode();
		static int count = Dlg->m_DiskDlg->m_DiskList.GetItemCount();
		
		pIWbemServices->ExecQuery(SysAllocString(L"WQL"),
			SysAllocString(L"select Caption,InterfaceType,Size from Win32_DiskDrive"),0,NULL,&pEnumCOMDevs);
		DebugInfo("Disk A");

		while( SUCCEEDED( pEnumCOMDevs->Next(2000,1,&pCOMDev,&uReturned )) && uReturned == 1){
			DebugInfo("Disk B");
			VARIANT  pVal;VariantClear(&pVal);
			CString Caption,Interface,Size;
			if( pCOMDev->Get(L"Caption",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL){
				Caption = pVal.bstrVal;VariantClear(&pVal);
			}
			if( pCOMDev->Get(L"InterfaceType",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL){
				Interface = pVal.bstrVal;VariantClear(&pVal);
			}
			if( pCOMDev->Get(L"Size",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL){
				Size = pVal.bstrVal;VariantClear(&pVal);
			}
			DebugInfo("Disk C");

			LVITEM myItem;
			memset(&myItem,0,sizeof(LVITEM));
			myItem.mask = LVIF_TEXT;
			char str[256];

			int i;
			BOOL Flag = FALSE;
			CString cstr2 = Caption;
			cstr2.Replace(" ","");
			for(i=0;i < count;i++){
				CString cstr1 = Dlg->m_DiskDlg->m_DiskList.GetItemText(i,0);
				cstr1.Replace(" ","");
				if( cstr1 == cstr2 ){
					Flag = TRUE;
				}
			}
			DebugInfo("Disk D");
			// Size  0 ̃foCX͕\Ȃ
			if( _atoi64(Size) == 0 ){Flag = TRUE;}
			// IDE/SCSI/USB 炢\ȂBȏ̓TCYIɖB
			if( Interface.GetLength() > 4 ){Interface = "";}
			if( Caption.Find("\\\\") != -1){Flag = TRUE;}
			if( Interface.Find("\\\\") != -1){Flag = TRUE;}

			if( ( Interface.Find("IDE") == -1 || FlagSafeMode ) && ! Flag )
			{
			DebugInfo("Disk E");
		// KvȂ
		//		wsprintf(str,"%d",myItem.iItem);MessageBox(str);
		//		LVFINDINFO lvf;lvf.flags = LVFI_STRING;lvf.psz = Caption;
		//		myItem.iItem = Dlg->m_DiskDlg->m_DiskList.FindItem(&lvf,myItem.iItem);

				myItem.iItem = Dlg->m_DiskDlg->m_DiskList.GetItemCount();
				Caption.Replace("SCSI Disk Device","");
				myItem.iSubItem = 0;sprintf(str,"%s",Caption);myItem.pszText = str;Dlg->m_DiskDlg->m_DiskList.InsertItem(&myItem);
				myItem.iSubItem = 1;sprintf(str,"%s",Interface);myItem.pszText = str;Dlg->m_DiskDlg->m_DiskList.SetItem(&myItem);
				myItem.iSubItem = 2;sprintf(str,"%0.1f",(_atoi64(Size) / 1000 / 1000 / 100) / 10.0);myItem.pszText = str;Dlg->m_DiskDlg->m_DiskList.SetItem(&myItem);
#ifndef CRYSTAL_SYS_INFO
				Dlg->m_RankingDlg->m_DiskNameUserC.InsertString(0,Caption);
#endif
			}
			pCOMDev->Release();
		}
		DebugInfo("Disk F");
		//AT[VG[
		//Dlg->m_DiskDlg->SetDiskDetailInfo(0);
		Dlg->m_DiskDlg->m_NumberOfItem = Dlg->m_DiskDlg->m_DiskList.GetItemCount();
		}catch(...){
			DebugInfo("Exception Disk");
		}
	}
/////////////////
//BIOS
	if( CheckWMIFlag("DisableWMI_BIOS") == 0 ){
		try{
		DebugInfo("BIOS");

		pIWbemServices->ExecQuery(SysAllocString(L"WQL"),
			SysAllocString(L"select ReleaseDate,Version,Manufacturer,Caption,SMBIOSBIOSVersion,SMBIOSMajorVersion,SMBIOSMinorVersion from Win32_BIOS"),0,NULL,&pEnumCOMDevs);

		DebugInfo("BIOS 1");
		if( SUCCEEDED( pEnumCOMDevs->Next(2000,1,&pCOMDev,&uReturned )) && uReturned == 1){
			VARIANT  pVal;VariantClear(&pVal);
			DebugInfo("BIOS 2");
			if( pCOMDev->Get(L"ReleaseDate",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				DebugInfo("BIOS 3");
				cstr = pVal.bstrVal;
				if(cstr.GetLength() >= 8 && atoi(cstr) > 0){
					DebugInfo("BIOS 4");
					strncpy(text,(LPCSTR)cstr,4);strcpy(text+4,"/");
					strncpy(text+5,(LPCSTR)cstr+4,2);strcpy(text+7,"/");
					strncpy(text+8,(LPCSTR)cstr+6,2);strcpy(text+10,"\0");
					Dlg->m_SystemDlg->m_SysBiosDate = " ";
					Dlg->m_SystemDlg->m_SysBiosDate += text;
					Dlg->m_SystemDlg->m_SysBiosDate.Replace("190","200");
					DebugInfo("BIOS 5");
				}
				VariantClear(&pVal);
				DebugInfo("BIOS 6");
			}

			if( pCOMDev->Get(L"Version",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_SystemDlg->m_SysBiosVersion = " ";
				Dlg->m_SystemDlg->m_SysBiosVersion += pVal.bstrVal;
				VariantClear(&pVal);
			}
			if( pCOMDev->Get(L"Manufacturer",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_SystemDlg->m_SysBiosManufacturer = " ";
				Dlg->m_SystemDlg->m_SysBiosManufacturer += pVal.bstrVal;
				VariantClear(&pVal);
			}
			if( pCOMDev->Get(L"Caption",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_SystemDlg->m_SysBiosCaption = " ";
				Dlg->m_SystemDlg->m_SysBiosCaption += pVal.bstrVal;
				VariantClear(&pVal);
			}
			if( pCOMDev->Get(L"SMBIOSBIOSVersion",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_SystemDlg->m_SysBiosSMBiosVersion = " ";
				Dlg->m_SystemDlg->m_SysBiosSMBiosVersion += pVal.bstrVal;
				VariantClear(&pVal);
			}
			if( pCOMDev->Get(L"SMBIOSMajorVersion",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_SystemDlg->m_SysBiosSMVersion.Format(" %d",pVal.ulVal);
				VariantClear(&pVal);
			}
			if( pCOMDev->Get(L"SMBIOSMinorVersion",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				cstr.Format(".%d",pVal.ulVal);
				Dlg->m_SystemDlg->m_SysBiosSMVersion += cstr;
			}
			pCOMDev->Release();
		}}catch(...){
			DebugInfo("Exception BIOS");
		}
	}

/////////////////
//Computer System
	if( CheckWMIFlag("DisableWMI_SYSTEM") == 0 ){
		try{
		DebugInfo("Computer System");

		pIWbemServices->ExecQuery(SysAllocString(L"WQL"),
			SysAllocString(L"select Manufacturer,Model from Win32_ComputerSystem"),0,NULL,&pEnumCOMDevs);

		if( SUCCEEDED( pEnumCOMDevs->Next(2000,1,&pCOMDev,&uReturned )) && uReturned == 1){
			VARIANT  pVal;VariantClear(&pVal);
			if( pCOMDev->Get(L"Manufacturer",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_SystemDlg->m_SysSystemManufacturer = " ";
				Dlg->m_SystemDlg->m_SysSystemManufacturer += pVal.bstrVal;
				VariantClear(&pVal);}
			if( pCOMDev->Get(L"Model",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_SystemDlg->m_SysSystemModel = " ";
				Dlg->m_SystemDlg->m_SysSystemModel += pVal.bstrVal;
			}
		//	Dlg->m_SystemDlg->UpdateData(FALSE);
			pCOMDev->Release();
		}}catch(...){
			DebugInfo("Exception Computer System");
		}
	}
/////////////////
//Mother
	if( CheckWMIFlag("DisableWMI_MOTHER") == 0 ){
		try{
		DebugInfo("Mother");
		pIWbemServices->ExecQuery(SysAllocString(L"WQL"),
			SysAllocString(L"select Manufacturer,Product,Version from Win32_BaseBoard"),0,NULL,&pEnumCOMDevs);
		if( SUCCEEDED( pEnumCOMDevs->Next(2000,1,&pCOMDev,&uReturned )) && uReturned == 1){
			VARIANT  pVal;VariantClear(&pVal);
			if( pCOMDev->Get(L"Version",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_SystemDlg->m_SysMotherVersion = " ";
				Dlg->m_SystemDlg->m_SysMotherVersion += pVal.bstrVal;
				VariantClear(&pVal);
			}
			if( pCOMDev->Get(L"Product",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_SystemDlg->m_SysMotherProduct = " ";
				Dlg->m_SystemDlg->m_SysMotherProduct += pVal.bstrVal;
				VariantClear(&pVal);
			}
			if( pCOMDev->Get(L"Manufacturer",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_SystemDlg->m_SysMotherManufacturer = " ";
				Dlg->m_SystemDlg->m_SysMotherManufacturer += pVal.bstrVal;
			}
		//	Dlg->m_SystemDlg->UpdateData(FALSE);
			pCOMDev->Release();
		}}catch(...){
			DebugInfo("Exception Mother");
		}
	}
/////////////////
//OS
	if( CheckWMIFlag("DisableWMI_OS") == 0 ){
		try{
		DebugInfo("OS");
		pIWbemServices->ExecQuery(SysAllocString(L"WQL"),
			SysAllocString(L"select Caption,Version,CSDVersion,InstallDate from Win32_OperatingSystem"),0,NULL,&pEnumCOMDevs);
		if( SUCCEEDED( pEnumCOMDevs->Next(2000,1,&pCOMDev,&uReturned )) && uReturned == 1){
			VARIANT  pVal;VariantClear(&pVal);
			if( pCOMDev->Get(L"InstallDate",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				cstr = pVal.bstrVal;
				if(cstr.GetLength() >= 8){
					strncpy(text,(LPCSTR)cstr,4);strcpy(text+4,"/");
					strncpy(text+5,(LPCSTR)cstr+4,2);strcpy(text+7,"/");
					strncpy(text+8,(LPCSTR)cstr+6,2);strcpy(text+10,"\0");
					Dlg->m_SystemDlg->m_SysOSInstallDate = " ";
					Dlg->m_SystemDlg->m_SysOSInstallDate += text;
				}
			}

			//if( pCOMDev->Get(L"Version",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR){
			//	Dlg->m_SystemDlg->m_SysOSVersion = pVal.bstrVal;}
			//if( pCOMDev->Get(L"CSDVersion",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR){
			//	Dlg->m_SystemDlg->m_SysOSCSDVersion = pVal.bstrVal;}
			// if( pCOMDev->Get(L"Caption",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR){
			// cstr = pVal.bstrVal;cstr.Replace("Microsoft ","");
			// Dlg->m_SystemDlg->m_SysOSCaption = cstr;}
			// AT[VG[
			//	Dlg->m_SystemDlg->UpdateData(FALSE);
			pCOMDev->Release();
		}}catch(...){
			DebugInfo("Exception OS");
		}
	}

/////////////////
//IDE
	if( CheckWMIFlag("DisableWMI_IDE") == 0 ){
		try{
		DebugInfo("IDE");
		pIWbemServices->ExecQuery(SysAllocString(L"WQL"),
			SysAllocString(L"select Caption,Manufacturer from Win32_IDEController"),0,NULL,&pEnumCOMDevs);
		if( SUCCEEDED( pEnumCOMDevs->Next(2000,1,&pCOMDev,&uReturned )) && uReturned == 1){
			VARIANT  pVal;VariantClear(&pVal);
			if( pCOMDev->Get(L"Caption",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_DeviceDlg->m_DeviceIDE = " ";
				Dlg->m_DeviceDlg->m_DeviceIDE += pVal.bstrVal;
			}
			//if( pCOMDev->Get(L"Manufacturer",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR){
			//	Dlg->m_DeviceDlg->m_DeviceIDE = pVal.bstrVal;}
			pCOMDev->Release();
		}}catch(...){
			DebugInfo("Exception IDE");
		}
	}

/////////////////
//Video
	if( CheckWMIFlag("DisableWMI_VIDEO") == 0 ){
		try{
		DebugInfo("Video");
		pIWbemServices->ExecQuery(SysAllocString(L"WQL"),
			SysAllocString(L"select AdapterCompatibility,VideoProcessor,Caption,DriverVersion,DriverDate,AdapterRAM,InstalledDisplayDrivers from Win32_VideoController"),0,NULL,&pEnumCOMDevs);
		if( SUCCEEDED( pEnumCOMDevs->Next(2000,1,&pCOMDev,&uReturned )) && uReturned == 1){
			VARIANT  pVal;VariantClear(&pVal);
			DebugInfo("Video 1");
			// ܂ƂȃhCoĂȂꍇ NULL ԂĂ܂B
			if( pCOMDev->Get(L"AdapterCompatibility",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_DeviceDlg->m_DeviceVideoVendor = " ";
				Dlg->m_DeviceDlg->m_DeviceVideoVendor += pVal.bstrVal;
				VariantClear(&pVal);
			}
			DebugInfo("Video 2");
			if( pCOMDev->Get(L"Caption",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_DeviceDlg->m_DeviceVideoCaption = " ";
				Dlg->m_DeviceDlg->m_DeviceVideoCaption += pVal.bstrVal;
				VariantClear(&pVal);
			}
			DebugInfo("Video 3");
			if( pCOMDev->Get(L"VideoProcessor",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_DeviceDlg->m_DeviceVideoChip = " ";
				Dlg->m_DeviceDlg->m_DeviceVideoChip += pVal.bstrVal;
				VariantClear(&pVal);
			}
			DebugInfo("Video 4");

			BOOL flag = FALSE;
			if( pCOMDev->Get(L"InstalledDisplayDrivers",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				cstr = pVal.bstrVal;
				char version[256];
				strcpy(version,"");
				if( GetFileVersion(cstr,version) >= 1 ){
					Dlg->m_DeviceDlg->m_DeviceVideoDriverVersion = version;
					DebugInfo("VideoDriver GetFileVersion");
					flag = TRUE;
				}
				VariantClear(&pVal);
			}
			
			if( flag == FALSE && pCOMDev->Get(L"DriverVersion",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_DeviceDlg->m_DeviceVideoDriverVersion = pVal.bstrVal;
				DebugInfo("VideoDriver GetWMI");
				VariantClear(&pVal);
			}
			DebugInfo("Video 5");
			
			if( pCOMDev->Get(L"DriverDate",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				cstr = pVal.bstrVal;
				if(cstr.GetLength() >= 8){
					strncpy(text,(LPCSTR)cstr,4);strcpy(text+4,"/");
					strncpy(text+5,(LPCSTR)cstr+4,2);strcpy(text+7,"/");
					strncpy(text+8,(LPCSTR)cstr+6,2);strcpy(text+10,"\0");
					Dlg->m_DeviceDlg->m_DeviceVideoDriverDate = text;
				}
				VariantClear(&pVal);
			}
			DebugInfo("Video 6");

			if( pCOMDev->Get(L"AdapterRAM",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL ){
				Dlg->m_DeviceDlg->m_DeviceVideoRAM.Format("%d",pVal.ulVal >> 20);
#ifndef CRYSTAL_SYS_INFO
				Dlg->m_RankingDlg->m_VideoSizeUserC.SetWindowText(Dlg->m_DeviceDlg->m_DeviceVideoRAM);
#endif
			}
			pCOMDev->Release();
		}}catch(...){
			DebugInfo("Exception Video");
		}
	}
	if( pEnumCOMDevs ){pEnumCOMDevs->Release();pEnumCOMDevs = NULL;}
	if(pIWbemServices){pIWbemServices->Release();pIWbemServices = NULL;}

	DebugInfo(WMI_INIT_END);
	
	}catch(...){
		DebugInfo("Exception");
	}

	Dlg->m_MarkDlg->ChangeAllWindowStatus(TRUE,FALSE);

	Dlg->SetWindowTitle("");
	Dlg->m_WMIStatus = 1;
	return 0;
}